VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Books"
   ClientHeight    =   4005
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7260
   LinkTopic       =   "Form1"
   ScaleHeight     =   4005
   ScaleWidth      =   7260
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdMoveLeft 
      Caption         =   "<"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2760
      TabIndex        =   3
      Top             =   840
      Width           =   375
   End
   Begin VB.CommandButton cmdMoveRight 
      Caption         =   ">"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   360
      Width           =   375
   End
   Begin MSFlexGridLib.MSFlexGrid flxData 
      Height          =   1695
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   2990
      _Version        =   393216
      AllowUserResizing=   1
   End
   Begin MSFlexGridLib.MSFlexGrid flxData 
      Height          =   1695
      Index           =   1
      Left            =   3480
      TabIndex        =   1
      Top             =   120
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   2990
      _Version        =   393216
      AllowUserResizing=   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Move the selected row from one grid to the other.
Private Sub MoveBetweenGrids(ByVal flxFrom As MSFlexGrid, ByVal flxTo As MSFlexGrid)
Dim from_row As Integer
Dim to_row As Integer
Dim c As Integer

    from_row = flxFrom.Row
    to_row = flxTo.Rows
    flxTo.Rows = to_row + 1

    ' Loop through the columns copying values.
    ' In this case there is only one column
    ' but it's done in a loop for more general
    ' programs.
    For c = 0 To 0
        flxTo.TextMatrix(to_row, c) = flxFrom.TextMatrix(from_row, c)
    Next c

    ' Delete the original row.
    flxFrom.RemoveItem from_row

    ' Deselect the rows in the grids.
    flxFrom.Row = 0
    flxTo.Row = 0
    cmdMoveRight.Enabled = False
End Sub

' Move items from the right grid to the left grid.
Private Sub cmdMoveLeft_Click()
    MoveBetweenGrids flxData(1), flxData(0)
End Sub


' Move items from the left grid to the right grid.
Private Sub cmdMoveRight_Click()
    MoveBetweenGrids flxData(0), flxData(1)
End Sub


' Enable the appropriate movement buttons.
Private Sub flxData_Click(index As Integer)
    cmdMoveRight.Enabled = (flxData(0).Row > 0)
    cmdMoveLeft.Enabled = (flxData(1).Row > 0)
End Sub
Private Sub Form_Load()
Dim i As Integer
Dim db_file As String
Dim statement As String
Dim conn As ADODB.Connection
Dim rs As ADODB.Recordset
Dim c As Integer
Dim r As Integer
Dim col_wid() As Single
Dim field_wid As Single

    ' Prepare the grids.
    For i = 0 To 1
        With flxData(i)
            .Rows = 2
            .FixedRows = 1
            .FixedCols = 0
            .Rows = 1
            .Cols = 1
            .SelectionMode = flexSelectionByRow
        End With
    Next i

    With flxData(0)
        .TextMatrix(0, 0) = "Books I Own"
    End With

    With flxData(1)
        .TextMatrix(0, 0) = "Books I Need to Buy"
    End With

    ' Get the data.
    db_file = App.Path
    If Right$(db_file, 1) <> "\" Then db_file = db_file & "\"
    db_file = db_file & "books.mdb"

    ' Open a connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & db_file & ";" & _
        "Persist Security Info=False"
    conn.Open

    ' Select the data.
    statement = "SELECT Title FROM Books ORDER BY Title"

    ' Get the records.
    Set rs = conn.Execute(statement, , adCmdText)

    ' Display the values for each row.
    With flxData(0)
        r = 1
        Do While Not rs.EOF
            .Rows = .Rows + 1
            For c = 0 To rs.Fields.Count - 1
                .TextMatrix(r, c) = rs!Title
            Next c

            rs.MoveNext
            r = r + 1
        Loop
    End With

    ' Close the recordset and connection.
    rs.Close
    conn.Close
End Sub
Private Sub Form_Resize()
Dim wid As Single

    wid = (ScaleWidth - 120 - cmdMoveLeft.Width) / 2
    If wid < 120 Then wid = 120

    flxData(0).Move 0, 0, wid, ScaleHeight
    flxData(1).Move wid + 120 + cmdMoveLeft.Width, 0, wid, ScaleHeight
    flxData(0).ColWidth(0) = wid - 120
    flxData(1).ColWidth(0) = wid - 120

    cmdMoveLeft.Left = wid + 60
    cmdMoveRight.Left = wid + 60
End Sub
